﻿@using System.Web
@using System.Security.Claims
@model UserData
@{
    ViewData["Title"] = "Client Message Board";
    var role = User.FindFirst(ClaimTypes.Role)?.Value;
    var area = role == Roles.FirmPrincipal ? "firm-principal" : role == Roles.FirmAdmin ? "firm-admin" : "adviser";
}
<div class="container">
    <div class="card">
        <div class="card-header flex-wrap border-0 pt-6 pb-0">
            <div class="card-title mb-0">
                <div class="d-flex justify-content-between">
                    <div class="flex-grow-1 align-self-center card-label text-primary font-size-h3 font-weight-bold">
                        Client Message Board
                    </div>
                    <div class="align-self-center">
                        <button type="button" class="btn btn-sm btn-maroon font-weight-bold mr-5 font-size-h6" id="btn-notes-preview" data-toggle="modal" data-target="#note-preview-modal">
                            <i class="fas fa-eye text-white"></i>
                            <span id="upload-text">Preview</span>
                        </button>
                    </div>
                    <div class="align-self-center">
                        <button class="btn btn-sm btn-primary font-weight-bold mr-10 font-size-h6" id="btn-submit-2" type="button">
                            Save<i class="la la-save ml-3 icon-lg"></i>
                        </button>
                    </div>
                    <div class="align-self-center">
                        <a onclick="goBackAdviser('@area')" class="btn btn-sm btn-icon btn-outline-primary btn-hover-light-primary btn-circle" data-toggle="tooltip" title="Go Back">
                            <i class="fas fa-arrow-left"></i>
                        </a>
                    </div>
                </div>
            </div>
        </div>
        <div class="card-body pt-5">
            <form id="notes-frm">
                <div class="row mb-2">
                    <div class="col-12">
                        <textarea asp-for="ClientBoardMessage" class="form-control d-none"></textarea>
                    </div>
                </div>
                <div class="d-flex justify-content-end pt-4 border-top">
                    <button class="btn btn-primary font-weight-bold px-6 py-2 font-size-h4" id="btn-submit" type="button">
                        Save<i class="la la-save ml-3 icon-lg"></i>
                    </button>
                </div>
            </form>
        </div>
    </div>
</div>
<div class="modal" id="note-preview-modal" data-backdrop="static" tabindex="-1" role="dialog" aria-labelledby="staticBackdrop" aria-hidden="true">
    <div class="modal-dialog modal-lg" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLabel">Client Message Board Preview</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <i aria-hidden="true" class="ki ki-close"></i>
                </button>
            </div>
            <div class="modal-body">
                <div id="client-message-board-preview">
                </div>
            </div>
        </div>
    </div>
</div>

@section scripts{
    <script src="~/lib/ckeditor-classic.bundle.js" asp-append-version="true"></script>
    <script>
        var myEditor;
        ClassicEditor.create(document.querySelector('#ClientBoardMessage'))
            .then(editor => {
                myEditor = editor;
                $("#ClientBoardMessage").removeClass("d-none");
            });
        var validateLinks = function () {
            var validated = true;
            $(".ck-content a").each(function () {
                var url = $(this).attr("href");
                if (!isValidURL(url))
                    validated = false;
            });
            return validated;
        }
        $("#btn-submit,#btn-submit-2").click(function (e) {
            e.preventDefault();
            $(".alert").remove();
            var isValidLiks = validateLinks();
            if (isValidLiks) {
                var btn = KTUtil.getById(e.target.id);
                KTUtil.btnWait(btn, "spinner spinner-right spinner-white pr-15", "Please wait");
                $.post("adviser/home/saveclientmessageboard", { clientboardmessage: myEditor.getData() }, function (response) {
                    if (response.success) {
                        toastr.options = toastrOptions;
                        toastr.success(response.message);
                    }
                    KTUtil.btnRelease(btn);
                });
            }
            else
                _showFormMessage(`notes-frm`, "danger", "Click on Preview to check the issue.", "fas fa-exclamation-triangle")
        });
        $("#note-preview-modal").on('shown.bs.modal', function () {
            $("#client-message-board-preview").html(myEditor.getData());
            $("#client-message-board-preview a").each(function (i, item) {
                var href = $(this).attr("href");
                if (isValidURL(href))
                    $(this).attr('target', '_blank');
                if (!isValidURL(href)) {
                    var warningHtml =
                        `<span class="fa-stack pulse pulse-warning" data-toggle="tooltip" data-html="true" data-original-title="Please enter valid URL" data-placement="right" role = "button" >
                                                             <i class="fas fa-play fa-stack-1x text-dark icon-nm" style="transform: rotate(30deg);left:1px;top:3px"></i>
                                                             <i class="fas fa-exclamation-triangle fa-stack-1x text-warning"></i>
                                                             <span class="pulse-ring" style="margin-left:-4px;margin-top:-5px"></span>
                                                         </span>`;
                    $(this).after(warningHtml);
                    $('[data-toggle="tooltip"], .tooltip').tooltip("hide");
                    $('[data-toggle="tooltip"]').tooltip({ trigger: "hover" });
                    $(this).attr("href", `javascript:`);
                }
                else if (!href.includes("http"))
                    $(this).attr("href", `http://${href}`);
            });
        });
    </script>
}